"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _express = _interopRequireDefault(require("express"));

var _cookieParser = _interopRequireDefault(require("cookie-parser"));

var _bodyParser = _interopRequireDefault(require("body-parser"));

var _addStatic = _interopRequireDefault(require("./utils/addStatic"));

var _urlRewrite = _interopRequireDefault(require("./utils/urlRewrite"));

var _ssrMiddleware = _interopRequireDefault(require("./ssrMiddleware"));

var server = (0, _express["default"])();
server.disable('x-powered-by'); // 挂载虚拟目录

(0, _addStatic["default"])(server); // 解析 cookie

server.use((0, _cookieParser["default"])()); // 解析 post 提交的 data

server.use(_bodyParser["default"].json()); // 挂载 mock 数据路由

(0, _urlRewrite["default"])(server);
server.all('*', _ssrMiddleware["default"]);
var _default = server;
exports["default"] = _default;
module.exports = exports.default;