"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.array.some");

require("core-js/modules/es6.regexp.constructor");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.array.map");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.array.index-of");

var _url = _interopRequireDefault(require("url"));

var _path = _interopRequireDefault(require("path"));

var _axios = _interopRequireDefault(require("axios"));

function requireUncached(module) {
  delete require.cache[require.resolve(module)];
  return require(module);
}

function dispatcher(req, res, next, options) {
  return function (rule) {
    if (rule.from.test(req.path)) {
      if (rule.to.indexOf('require!') === 0) {
        // 使用本地文件模拟数据
        var urlObject = _url["default"].parse(req.url);

        var filepath = urlObject.pathname.replace(rule.from, rule.to).replace('require!', '');

        var realpath = _path["default"].join(process.cwd(), filepath);

        if (options.debug) {
          console.log("[urlrewrite] ".concat(req.url, " -> ").concat(realpath));
        }

        res.setHeader('Content-Type', 'application/json');
        requireUncached(realpath)(req, res);
      } else if (/^(https{0,1}:){0,1}\/\//.test(rule.to)) {
        // 使用跨域API模拟数据
        var toUrl = req.url.replace(rule.from, rule.to);

        if (options.debug) {
          console.log("[urlrewrite] ".concat(req.url, " -> ").concat(toUrl));
        }

        (0, _axios["default"])({
          method: req.method,
          url: toUrl,
          headers: req.headers,
          data: req.body
        }).then(function (response) {
          res.status(response.status).json(response.data).end();
        });
      } else {
        // 使用同域名的其他API模拟数据
        var _toUrl = req.url.replace(req.path, rule.to);

        req.url = _toUrl;

        if (options.debug) {
          console.log("[urlrewrite] ".concat(req.url, " -> ").concat(_toUrl));
        }

        next();
      }

      return true;
    }

    return false;
  };
}

function convertRules(data) {
  return Object.keys(data).map(function (from) {
    return {
      from: new RegExp(from),
      to: data[from]
    };
  });
}

var _default = function _default(rewriteTable, options) {
  options = options || {
    debug: false
  };
  var rules = convertRules(rewriteTable);
  return function (req, res, next) {
    if (rules.length === 0 || !rules.some(dispatcher(req, res, next, options))) {
      next();
    }
  };
};

exports["default"] = _default;
module.exports = exports.default;