"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

require("core-js/modules/es6.object.define-property");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("core-js/modules/es6.string.starts-with");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.array.filter");

require("core-js/modules/es6.array.reduce");

var _urlRewrite = _interopRequireDefault(require("../middlewares/urlRewrite"));

var _rewriteRules = _interopRequireDefault(require("../rewriteRules"));

var _default = function _default(app) {
  // 只在本地开发时使用 mock 数据
  var isDev = process.env.NODE_ENV === 'development';
  var rules = _rewriteRules["default"];

  if (!isDev) {
    rules = Object.keys(rules).filter(function (key) {
      return !rules[key].startsWith('require!');
    }).reduce(function (res, key) {
      res[key] = rules[key];
      return res;
    }, {});
  }

  app.use((0, _urlRewrite["default"])(rules, {
    debug: isDev
  }));
};

exports["default"] = _default;
module.exports = exports.default;